<?php
ini_set(
  'include_path',
  ini_get('include_path') . PATH_SEPARATOR . '/home/sgartner/pear/php'
);

require_once "HTTP/Request.php";

// This the minimum version of the script that this web service is
// documented to support. Changing this to a higher version number than
// the client script (see WootWatcherAjaxLibrary.js) will cause the web
// browser running the client to attempt to refresh the page which
// *should* retrieve a newer client script to handle a newer cache
// version. With care, this number can be raised temporarily to simply
// force all clients to refresh at least once and load a new script, but
// that will cause thrashing on the client, so don't do it without an
// excellent reason.
$scriptVersion=1.78;

// enable/disable logging (true/false)
$logging = false;

$stopwatch=microtime(TRUE);
$uniqueId = uniqid("WC", true);
$lockFileName = 'updating.dat';
$logFileName='/home/sgartner/wootoff.pingbot.com/error.log';
//$logFileName='D:/Web Sites/WootOff/error.log';

unset($old_error_handler);
unset($lockFP);

function myErrorHandler ($errno, $errstr, $errfile, $errline)
{
    global $lockFP;

    switch ($errno)
      {
        case E_USER_ERROR:
          // I don't actually care what kind of error is being handled, I just
          // want to make sure that if we have locked the updating.dat file we
          // unlock it before continuing so that we don't leave the lock
          // dangling.  Then we call the base error handler.
          if (isset ($lockFP))
            {
              logstring('Forcing lock file to be closed.');
              // Lock was there, closing the lock
              @fclose($lockFP);
              unset($lockFP);
            }
      }

    // Signal that we didn't handle the error, which will cause the default
    // handler to be called.
    return false;
}

// set to the user defined error handler
$old_error_handler = set_error_handler("myErrorHandler");


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
/**
* Replace stripos()
*
* @category PHP
* @package PHP_Compat
* @link http://php.net/function.stripos
* @author Aidan Lister <aidan@php.net>
* @version $Revision: 1.9 $
* @since PHP 5
* @require PHP 4.0.1 (trigger_error)
*/
if (!function_exists('stripos'))
{
    function stripos($haystack, $needle, $offset = null)
    {
        if (!is_scalar($haystack))
        {
            trigger_error('stripos() expects parameter 1 to be string, ' . gettype($haystack) . ' given', E_USER_WARNING);
            return false;
        }
        if (!is_scalar($needle))
        {
            trigger_error('stripos() needle is not a string or an integer.', E_USER_WARNING);
            return false;
        }
        if (!is_null($offset) && !is_numeric($offset))
        {
            trigger_error('stripos() expects parameter 3 to be long, ' . gettype($offset) . ' given', E_USER_WARNING);
            return false;
        }
        // Manipulate the string if there is an offset
        $fix = 0;
        if (!is_null($offset))
        {
            if ($offset > 0)
            {
                $haystack = substr($haystack, $offset, strlen($haystack) - $offset);
                $fix = $offset;
            }
        }
        $segments = explode(strtolower($needle), strtolower($haystack), 2);
        // Check there was a match
        if (count($segments) == 1)
        {
            return false;
        }
        $position = strlen($segments[0]) + $fix;
        return $position;
    }
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// replace file_put_contents
// (modified from above)

if (!function_exists('file_put_contents'))
{
    function file_put_contents($filename, $somecontent="")
    {
        if (!is_scalar($filename))
        {
            trigger_error('file_write() expects parameter 1 to be string, ' . gettype($haystack) . ' given', E_USER_WARNING);
            return FALSE;
        }
        if (!is_scalar($somecontent))
        {
            trigger_error('file_write() content is not a string or a number.', E_USER_WARNING);
            return FALSE;
        }
        if (!$handle = fopen($filename, "w"))
        {
            echo "ERROR: Cannot open file ($filename)";
            return FALSE;
        }
        if (fwrite($handle, $somecontent) === FALSE)
        {
            echo "ERROR: Cannot write to file ($filename)";
            return FALSE;
        }
        fclose($handle);
    }
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// log the passed string

if (!function_exists('logstring'))
{
    function logstring ($outString)
    {
        global $uniqueId, $logFileName;

        if ($logging)
          {
            error_log($uniqueId.' '.$outString."\n",
                      3,
                      $logFileName);
          }
    }
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// Define Settings
$lifespan=25; // DO NOT SET BELOW 10 - this is how old the cache can be
$retrydelay=4;

$debugFilename="foundWootHomePage.html";

$filename="cache.txt";
if (isset($_REQUEST['extended']))
  {
    $filename="cache_extended.txt";
  }

$imageCacheKey = "WOOTCACHEIMAGE-";

//Global Variables
$nextupdate=0;
$percentage="0%";
$description="";
$price="";
$timestamp="";
$buylink="";
$forumlink="";
$imagelink="";
$imageextension="";
$wootoffstate=3;  // 1=over 2=running 3=unknown  +10 if button is bouncing
$productCondition="new"; // New, refurb, etc.
$age=0;
$errorstring="";

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// This function downloads the remove WOOT image and then saves a
// full-sized version and a thumbnail. It uses GD to resize the image
// (if available) and will default to saving the full-sized image as the
// thumbnail (in which case the HTML will resize the image dynamically).
//
function cacheImages ($imagelink, $imageName, $imageextension)
{
    global $imageCacheKey;

    // Note: If you change this size you will also need to update the
    // HTML file to also have the same size on the product thumbnail
    // image, or you will get ugly results. The HTML *must* have an
    // image width because it is the backup plan for resizing the image
    // properly in case the server doesn't support GD.
    $maxImageSize = 200;

    // First remove any previously cached images.
    $dirpath = ".";
    $dh = opendir($dirpath);
    while (false !== ($file = readdir($dh)))
      {
        // Ignore subdirectories
        if (!is_dir("$dirpath/$file") && preg_match("/^$imageCacheKey.+/", $file))
          {
            unlink($file);
          }
      }

     closedir($dh);

    // We first download the remote image using HTTP_Request. We can't
    // just use imageCreateFromJPEG() in case the server has dissallowed
    // these functions from accessing the network (a common limitation
    // these days). Once we have written the local copy, then we can use
    // the GD library to resize the image into a thumbnail (size defined
    // above).
    $timeout = 3; // seconds, set to zero for no timeout
    logstring("Requesting Image: ".$imagelink."-standard.".$imageextension);
    $req =& new HTTP_Request($imagelink."-standard.".$imageextension,
                             array('keepAlive' => true,
                                   'timeout' => $timeout));

    if (!PEAR::isError($req->sendRequest()))
      {
        $img = $req->getResponseBody();
      }
    else
      {
        logstring($req->getMessage());
        return;
      }

    file_put_contents($imageName."-standard.".$imageextension, $img);

    // Put image.jpg for backwards compatibility
    file_put_contents("image.".$imageextension, $img);

    // Write out the thumbnail image

    // Since we can't trust WOOT to name the images
    // consistently, resize this image using GD, if GD is
    // installed. Otherwise, just use CURL to read the file
    // and write the big image into both the full-sized and
    // the thumbnail file.
    if (function_exists("imagecreatefromjpeg"))
      {
        if ($imageextension == "jpg")
          $img = @imageCreateFromJPEG($imageName."-standard.".$imageextension);
        else if ($imageextension == "gif")
          $img = @imageCreateFromGIF($imageName."-standard.".$imageextension);
        else if ($imageextension == "png")
          $img = @imageCreateFromPNG($imageName."-standard.".$imageextension);

        $imageWidth  = imagesX($img);
        $imageHeight = imagesY($img);

        $scale = $maxImageSize/(  $imageWidth > $imageHeight
                                ? $imageWidth
                                : $imageHeight);

        $newX = $imageWidth*$scale;
        $newY = $imageHeight*$scale;

        $dest = imageCreateTrueColor($newX, $newY);

        imageCopyResampled($dest,        $img,
                           0, 0,         0, 0,
                           $newX, $newY, $imageWidth, $imageHeight);

        if ($imageextension == "jpg")
          imageJPEG($dest, $imageName."-thumbnail.".$imageextension, 75);
        else if ($imageextension == "gif")
          imageGIF($dest, $imageName."-thumbnail.".$imageextension, 75);
        else if ($imageextension == "png")
          imagePNG($dest, $imageName."-thumbnail.".$imageextension, 75);

        imageDestroy($dest);
        imageDestroy($img);
      }
    else
      {
        file_put_contents($imageName."-thumbnail.".$imageextension, $img);
      }

    if (strlen($img) > 0)
      file_put_contents("image.txt", $imagelink);
}

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

// open file and read in contents
$cache=@file_get_contents($filename);

// parse nextupdate time from the cache
if (!(stripos($cache,"||")===FALSE))  //verify a valid cache
{
   if (stripos($cache, "#BMSG#") == 0)
     {
       $nextupdate=substr($cache, 6, 10);
     }
   else if (stripos($cache, "#BM#") == 0)
     {
       $nextupdate=substr($cache, 4, 10);
     }
   else
     {
       $nextupdate=0;
     }
}
else
{
   $cache="";
}

// Decide if the cache should be used or if it should be updated
if (time() < $nextupdate)
{
    // use data from cache
    $startpos=0;
    for($i=0;$i<3;$i++)
        $startpos=stripos($cache,"||",$startpos)+2;
    $endpos=stripos($cache,"||",$startpos);
    $age=time()-substr($cache,$startpos,$endpos-$startpos);
}
else
{
    $updatedCache = false;

    // check to see if another instance is already updating the cache
    // this is important since a checker site can take many hits per
    // second and the update process can take over 1 second sometimes.
    // Attempt to open the semaphore file for writing.
    $lockFP = fopen($lockFileName, 'w');
    if (!@flock($lockFP, LOCK_EX+LOCK_NB, $wouldblock))
      {
        if (strlen($cache) > 0)
          {
            logstring("Reading from cache");
            // use data from cache
            $startpos=0;
            for($i=0;$i<3;$i++)
                $startpos=stripos($cache,"||",$startpos)+2;
            $endpos=stripos($cache,"||",$startpos);
            $age=time()-substr($cache,$startpos,$endpos-$startpos);
          }
      }
    else
      {
        // retrieve woot page
        $timeout = 30; // seconds, set to zero for no timeout
        logstring('Requesting Page: http://www.woot.com');
        $req =& new HTTP_Request('http://www.woot.com/',
                                 array('keepAlive' => true,
                                       'timeout' => $timeout));

        $results = $req->sendRequest();

        if (!PEAR::isError($results))
          {
            $file = $req->getResponseBody();
            $httpErrorNumber = 0;
            $httpErrorString = "";
          }
        else
          {
            $file = "";
            $httpErrorNumber = $req->getResponseCode();
            $httpErrorString = $results;
          }

        $errorstring="Woot Page Downloaded";

        // Verify the downloaded page is complete by looking for the
        // closing </html> tag and make sure it is really the Woot home
        // page (and not some ASP error page) by looking for "Welcome to
        // Woot".
        if (   $httpErrorNumber
            || (strlen($file) == 0)
            || (stripos($file,"</html>") === FALSE)
            || (stripos($file, "Welcome to Woot") === FALSE))
          {
            // If the download is corrupted, this iteration will
            // need to abort it's attempt to update the cached
            // info and just use the current cache for the data.
            // However, the cache still needs to be changed a
            // little bit. If a method of setting a delay before
            // the next try is not used, the woot servers could
            // get flooded if the site ever experiences a prolonged
            // glitch.  The solution is to pencil in a new next
            // update time along with the already existing data.

            // file_put_contents($debugFilename, $file);

            $errorstring="Retrieval of Woot Homepage Failed";
            if (strlen($cache) < 20)
              {
                $cache=$errorstring;
                $cache=$httpErrorNumber . ": " .$httpErrorString;
              }
            else
              {
                $startpos=0;
                for($i=0;$i<3;$i++)
                    $startpos=stripos($cache,"||",$startpos)+2;
                $endpos=stripos($cache,"||",$startpos);
                $age=time()-substr($cache,$startpos,$endpos-$startpos);
                $olddata=substr($cache,14,strlen($cache)-14);
                $newcache="#BM#".(string)($nextupdate+$retrydelay).$olddata;
                $dummy = file_put_contents($filename,$newcache);
              }
          }
        else
          {
            // get rid of the bottom half of the page + a bit off the top
            $startpos=stripos($file,"</ul>")+5;
            $endpos=stripos($file,"SubTitleHeader");
            $file=substr($file,$startpos,$endpos);

            // time to start looking for stuff

            //--------------- PARSE PERCENTAGE ---------------
            $FLAG_foundpercentage=FALSE;
            #$percentage="N/A";
            $percentage="-1";
            $startpos=stripos($file,"<div class=\"bar\" style='width: ");
            if(!($startpos===FALSE))
            {
                $startpos=$startpos+31;
                $endpos=stripos($file,"%");
                if($endpos-$startpos<4)
                {
                    $percentage=substr($file,$startpos,$endpos-$startpos)."%";
                    $FLAG_foundpercentage=TRUE;
                }
            }

            //--------------- PARSE DESCRIPTION --------------
            $startpos=stripos($file,"ctl00_ContentPlaceHolder_TitleHeader")+38;
            $endpos=stripos($file,"</",$startpos);
            $description=substr($file,$startpos,$endpos-$startpos);
            $description=str_replace("×", "x", $description);
            $description=str_replace("–", "-", $description);

            //------------------ PARSE PRICE -----------------
            $startpos=stripos($file,"PriceSpan")+11;
            $endpos=stripos($file,"</",$startpos);
            $price=substr($file,$startpos,$endpos-$startpos);

            //----------------- PARSE CONDITION --------------
            $startpos=stripos($file,"ConditionSpan")+15;
            $endpos=stripos($file,"</",$startpos);
            $productCondition=substr($file,$startpos,$endpos-$startpos);
            $productCondition=preg_replace("/\s{2,}/","",$productCondition);

            //--------------- PARSE FORUM LINK ---------------
            $startpos=stripos($file,"ctl00_ContentPlaceHolder_ForumsLink")+36;
            $startpos=stripos($file,"href=",$startpos)+26;
            $endpos=stripos($file,">",$startpos)-1;
            $forumlink="/".substr($file,$startpos,$endpos-$startpos);

            //--------------- PARSE IMAGE LINK ---------------
            $startpos=stripos($file,"ctl00_ContentPlaceHolder_SaleImage")+34;
            $startpos=stripos($file,"src=",$startpos)+5;
            $endpos=stripos($file,"\"",$startpos);
            $imagelink=substr($file,$startpos,$endpos-$startpos);
            $imageextension=substr($imagelink,strlen($imagelink)-3,3);

            // Pull the -standard.xxx off of the image.
            $imagelink=substr($imagelink,0,strlen($imagelink)-13);
            $urlArray = parse_url($imagelink);
            $pathArray = split('/', $urlArray['path']);
            $imageName = $imageCacheKey.$pathArray[count($pathArray)-1];

            //-------------- PARSE PURCHASE LINK -------------
            $FLAG_foundbuylink=FALSE;
            $startpos=stripos($file,"WantOne.aspx?");
            if(!($startpos===FALSE))
            {
                $endpos=stripos($file,">",$startpos)-1;
                $buylink=substr($file,$startpos,$endpos-$startpos);
                $buylink="/".$buylink;
                $FLAG_foundbuylink=TRUE;
            }
            else
            {
                $buylink="/";
            }

            //------------- PARSE SOLD OUT BUTTON ------------
            $FLAG_foundsoldout=FALSE;
            if(!(stripos($file,"ctl00_ContentPlaceHolder_SoldOutPanel")===FALSE))
            {
                $percentage="0%";
                $FLAG_foundsoldout=TRUE;
            }

            //------------- PARSE BOUNCING BUTTON ------------
            $FLAG_foundbouncingbutton=FALSE;
            if(!(stripos($file,"ctl00_ContentPlaceHolder_UrgentPurchaseBoxPanel")===FALSE))
            {
                $FLAG_foundbouncingbutton = TRUE;
            }

            //--------------- IS WOOT-OFF OVER ---------------
            // 1=over 2=running 3=unknown
            $oldstate=substr($cache,strlen($cache)-2,1);
            if (($oldstate!=1)&&($oldstate!=2))
              $oldstate=3;

            if ($oldstate!=3)
              {
                $wootoffstate=$oldstate;
                if(($oldstate==2)&&($FLAG_foundbuylink)&&(!($FLAG_foundpercentage))&&(!($FLAG_foundsoldout)))
                    $wootoffstate=1;
                if(($oldstate==1)&&($FLAG_foundpercentage))
                    $wootoffstate=2;
              }
            else
              {
                if ($FLAG_foundpercentage)
                  {
                   $wootoffstate=2;
                  }
                else
                  {
                   if (($FLAG_foundbuylink)&&(!($FLAG_foundpercentage)))
                     {
                       $wootoffstate=1;
                     }
                   else
                     {
                       $wootoffstate=3;
                     }
                  }
              }
            // if the button is bouncing, add 10 to the wootoff state
            if ($FLAG_foundbouncingbutton) $wootoffstate = $wootoffstate + 10;
            //------------------------------------------------

            // Update Image Cache
            $oldimagelink=@file_get_contents("image.txt");
            if ($oldimagelink != $imagelink)
              {
                cacheImages($imagelink, $imageName, $imageextension);
                $message2="New Image Cached";
              }

            // set timestamps
            $timestamp=time();
            $nextupdate=time()+$lifespan;

            // update cache
            $cache="#BM#"; //Script Mod Identifier
            if (isset($_REQUEST['extended']))
              {
                $cache="#BMSG#"; //Script Mod Identifier BMSG = sgartner mod
              }

            $cache=$cache.(string)$nextupdate."||";
            $cache=$cache.$percentage."||";
            $cache=$cache.$description."||";
            $cache=$cache.$timestamp."||";
            $cache=$cache.$buylink."||";
            $cache=$cache.$price."||";
            $cache=$cache.$forumlink."||";

            if (isset($_REQUEST['extended']))
              {
                $cache=$cache.$imageName."||";
              }

            $cache=$cache.$imageextension."||";
            $cache=$cache.(string)$wootoffstate."||"; // 1=over 2=running 3=unknown

            if (isset($_REQUEST['extended']))
              {
                $cache=$cache.$productCondition."||"; //new, refurb, etc.
                $cache=$cache.$scriptVersion."||";
              }

            $dummy = file_put_contents($filename,$cache);

            $age=time()-$timestamp;
          }

        $updatedCache = true;
        logstring('Completed Processing Page!');
      }

    if (isset($lockFP))
      {
        @fclose($lockFP);
        unset($lockFP);

        if ($updatedCache)
          {
            // Trying a new thing to fix occassional lock-up problems at
            // high stress.
            // Try 50 times to unlink the lock file.
            $count = 0;
            while (file_exists($lockFileName) && $count < 50)
              {
                unlink($lockFileName);
                $count += 1;
              }

            logstring("Unlinking lock file, took $count tries.");
          }
      }
}

$stopwatch=microtime(TRUE)-$stopwatch;

// output the data
print $cache;
if(strlen((string)$stopwatch)>6)
    {print substr((string)$stopwatch,0,6);}
else
    {print $stopwatch;}

// Add age and expected client version number
print "||$age||$scriptVersion||";

// print $errorstring;
?>
